//+------------------------------------------------------------------+
//|                                            
//+------------------------------------------------------------------+
#include <stderror.mqh>
#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2


extern int MagicNumber = 456879;
extern double Risk = 10;
extern double SL = 650;
extern double TP = 1800;


int BarCount;
int Current;
bool dummyResult;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   BarCount = Bars;
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   int Order = SIGNAL_NONE;
   int Total, Ticket;
   
   Total = OrdersTotal();
   Order = SIGNAL_NONE;
//+------------------------------------------------------------------+
//| Variable Begin                                                   |
//+------------------------------------------------------------------+


   int timeFrame = 240;
   
      double BuyPT1_1 = iCustom(NULL,timeFrame,"PriceTrender",0,0,0,0,24,1,2); //trend before
      double BuyPT1_2 = iCustom(NULL,timeFrame,"PriceTrender",0,0,0,0,24,1,1); //trend now
      double BuyPT2_1 = iCustom(NULL,timeFrame,"PriceTrender",0,0,0,0,24,0,2); //price before
      double BuyPT2_2 = iCustom(NULL,timeFrame,"PriceTrender",0,0,0,0,24,0,1); // price now

      double SellPT1_1 = iCustom(NULL,timeFrame,"PriceTrender",0,0,0,0,24,1,2);//trend before
      double SellPT1_2 = iCustom(NULL,timeFrame,"PriceTrender",0,0,0,0,24,1,1);//trend now
      double SellPT2_1 = iCustom(NULL,timeFrame,"PriceTrender",0,0,0,0,24,0,2);//price before
      double SellPT2_2 = iCustom(NULL,timeFrame,"PriceTrender",0,0,0,0,24,0,1);//price now

   //+------------------------------------------------------------------+
   //| Variable End                                                     |
   //+------------------------------------------------------------------+
   //| Signal Begin(Entry long & Entry short)   

   Order = SIGNAL_NONE;
      if (BuyPT2_1  < BuyPT1_1  && BuyPT2_2  > BuyPT1_2)  Order = SIGNAL_BUY;
      if (SellPT2_1 > SellPT1_1 && SellPT2_2 < SellPT1_2) Order = SIGNAL_SELL;


   //+------------------------------------------------------------------+
   //| Signal End                                                       |
   //+------------------------------------------------------------------+

   //Buy
   
   double LOTS= NormalizeDouble(AccountFreeMargin()*Risk/100000,1);
   if ((Order == SIGNAL_BUY))
   {
      if (!closeOposite(OP_SELL)) return(0);
         //Check free margin
         if (AccountFreeMargin() < (1000 * LOTS)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

        
       Ticket = OrderSend(Symbol(), OP_BUY, LOTS, Ask, 0, 0, 0, "Buy(#" + MagicNumber + ")", MagicNumber, 0, DodgerBlue);
       dummyResult= OrderSelect(Ticket,SELECT_BY_TICKET);
       dummyResult= OrderModify(Ticket,OrderOpenPrice(),OrderOpenPrice()- SL*Point,OrderOpenPrice()+ TP*Point,0,Red);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("BUY order opened : ", OrderOpenPrice());
                
			} else {
				Print("Error opening BUY order : ", GetLastError());
			}
         }
         return(0);
   }

   //Sell
   if ((Order == SIGNAL_SELL))
   {
      if (!closeOposite(OP_BUY)) return(0);
         BarCount = Bars;
     
         //Check free margin
         if (AccountFreeMargin() < (1000 * LOTS)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

        Ticket = OrderSend(Symbol(), OP_SELL, LOTS, Bid, 0, 0, 0, "Sell(#" + MagicNumber + ")", MagicNumber, 0, DeepPink);
        dummyResult= OrderSelect(Ticket,SELECT_BY_TICKET);
        dummyResult= OrderModify(Ticket,OrderOpenPrice(),OrderOpenPrice() + SL*Point,OrderOpenPrice()-TP*Point,0,Red);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("SELL order opened : ", OrderOpenPrice());
                
			} else {
				Print("Error opening SELL order : ", GetLastError());
			
         }
         return(0);
      }
   }

   BarCount = Bars;

   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool closeOposite(int orderType)
{
   bool answer=true;
   for(int i=0; i<OrdersTotal(); i++) 
   {
      dummyResult= OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (OrderMagicNumber()!= MagicNumber) continue;
      if (OrderSymbol() != Symbol())        continue;
 
      //
      //
      //    close the "oposite" order because a new order 
      //    in a oposite direction is going to be opened
      //
      //
      
      if (orderType==OP_BUY  && OrderType()==OP_SELL) { Comment("sell found"); return(false); }
      if (orderType==OP_SELL && OrderType()==OP_BUY)  { Comment("buy found");  return(false); }
      if (OrderType() == orderType) 
      {
         answer = false;
         for(int c=0 ; c<3; c++)
         {
            RefreshRates();
            if (OrderType()==OP_BUY)
                  double cp = Bid;  
            else         cp = Ask;
               
            //
            //
            //
            //
            //
               
            ResetLastError();                  
            dummyResult= OrderClose(OrderTicket(),OrderLots(),cp,0,CLR_NONE);
            int err=GetLastError();
     			switch (err)
            {
    			   case ERR_SERVER_BUSY:
               case ERR_NO_CONNECTION:
               case ERR_INVALID_PRICE:
               case ERR_OFF_QUOTES:
               case ERR_BROKER_BUSY:
               case ERR_TRADE_CONTEXT_BUSY:
                    Sleep(250);
                    continue;

               case ERR_PRICE_CHANGED:
               case ERR_REQUOTE:
    	              continue;

               default:
                    answer = true; c=3; continue;
            }
         }
      }
   }
   return(answer);
}